#! /usr/bin/perl -w

# Luis Lopez


use File::Find;
use File::Compare;

find(\&wanted, @ARGV);   # Find files inside the specified directory recusively

# compare the files to see if they are equal
while (@fileList) {
   $compareFile = shift @fileList;   # remove the first element from the array to compare it with the rest of the files

   $firstInstance = 1;
   $i = 0;
   if ( $compareFile ne '-' ) {   # skip the files marked with '-', which means they've already been successfully compared.
      foreach $file2(@fileList) {
         if ( compare($compareFile, $file2) == 0 ) {   # compare the two files
            if ( $firstInstance == 1 ) {   # print title "duplicates" if this is the first duplicate file encountered
               print "duplicates:\n $compareFile\n";
               $firstInstance = 0;
            }
            print " $file2\n";
            $fileList[$i] = '-'; # mark this file (i.e. we don't have to compare it with other files, anymore)
         }
         $i++;
      }   # end foreach
   }   # end if
}

sub wanted {
   if (!-d && !-z && !-l && !-b && !-c) {   # Ignore directories, zero-byte files, symbolic links, and device files
      $fileName = $File::Find::name;
      push(@fileList, $fileName);   # store the filenames in an array
   }
}
